#include <string.h>
#include <stdlib.h>

/* useful constants */
#define SIZE 1024
#define WIDTH 16
#define HEIGHT 16
#define COLORS 30 /* should be enought for all puzzles */
#define ANY (COLORS-1)

/* types */
enum directions { up = 0, right = 1, down = 2, left = 3};
typedef char piece[4];

/* global variables */
piece pieces[WIDTH * HEIGHT + 1];
piece rotations[4 + 4 * WIDTH * HEIGHT];
int curgrid[WIDTH][HEIGHT], ishint[WIDTH][HEIGHT];
char onboard[WIDTH * HEIGHT + 1];
int havecolors[COLORS][COLORS][4 + 4 * WIDTH * HEIGHT + 1];
int best;
long long pps, pps_optim, pps_swap, pps_total, pps_restart;
int x[WIDTH*HEIGHT], y[WIDTH*HEIGHT];
float coeff1, coeff2, coeff3, coeff4, coeff5, coeff6, coeff7, coeff8;
int maxskip[WIDTH * HEIGHT];

/* user interface */
int gui;
int minigui;
int benchmark;
int drawnow;
int drawnow_mini;

void save(int grid[WIDTH][HEIGHT], int score);
void draw();
void draw_mini();
void fill(int step, int score, int skipped);
